"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const testing_1 = require("@seagull/testing");
require("chai/register-should");
const mocha_typescript_1 = require("mocha-typescript");
const src_1 = require("../../src");
const handle_ssm_secret_1 = require("../../src/handle_ssm_secret");
let Test = class Test extends testing_1.BasicTest {
    before() {
        return __awaiter(this, void 0, void 0, function* () {
            yield testing_1.BasicTest.prototype.before.bind(this)();
        });
    }
    after() {
        return __awaiter(this, void 0, void 0, function* () {
            yield testing_1.BasicTest.prototype.after.bind(this)();
        });
    }
    'can create a pipeline'() {
        return __awaiter(this, void 0, void 0, function* () {
            const props = {
                appPath: `${process.cwd()}/test_data`,
                branch: 'master',
                githubToken: 'Token123',
                mode: 'prod',
                owner: 'me',
                profile: 'default',
                region: 'eu-central-1',
                repository: 'test-repo',
                ssmHandler: new TestSSMHandler({ Token123: '123' }),
            };
            const pipeline = yield new src_1.SeagullPipeline(props).createPipeline();
            const synthStack = pipeline.synthesizeStack('helloworld-ci');
            Object.keys(synthStack.template.Resources).length.should.be.equals(8);
        });
    }
};
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], Test.prototype, "can create a pipeline", null);
Test = __decorate([
    mocha_typescript_1.suite('SeagullPipeline')
], Test);
exports.Test = Test;
class TestSSMHandler extends handle_ssm_secret_1.SSMHandler {
    constructor(testData) {
        super();
        this.mockStore = testData || {};
    }
    getParameter(ssmName) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.mockStore[ssmName] || '';
        });
    }
    createParameter(name, value) {
        return __awaiter(this, void 0, void 0, function* () {
            this.mockStore[name] = value;
            return;
        });
    }
}
//# sourceMappingURL=seagull_pipeline.js.map